program PExample;

	uses
		Types,
		
		ICAPI;

	function LaunchURLPascal(urlStr : Str255) : OSStatus;
		var
			err : OSStatus;
			junk : OSStatus;
			inst: ICInstance;
			startSel : longint;
			endSel : longint;
	begin
		err := ICStart(inst, '????');			(* Use your creator code if you have one! *)
		if err = noErr then begin
			err := ICFindConfigFile(inst, 0, nil);
			if err = noErr then begin
				startSel := 0;
				endSel := length(urlStr);
				err := ICLaunchURL(inst, '', @urlStr[1], length(urlStr), startSel, endSel);
			end; (* if *)
			junk := ICStop(inst);
		end; (* if *)
		LaunchURLPascal := err;
	end; (* LaunchURLPascal *)
	
	function LaunchURLC(urlStr : Str255) : OSStatus;
		C;
		external;
		
	var
		urlStr : Str255;
		pOrC : char;
		err : OSStatus;
begin
	writeln('ICLaunchURL  A simple IC sample.');
	writeln('Enter the URL you would like to launch:');
	readln(urlStr);
	if urlStr <> '' then begin
		writeln('Enter p for the Pascal implementation or c for the C implementation.');
		readln(pOrC);
		if pOrC = 'p' then begin
			err := LaunchURLPascal(urlStr);
		end else begin
			err := LaunchURLC(urlStr);
		end; (* if *)
		if err = noErr then begin
			writeln('Success!');
		end else begin
			writeln('Failed with error ', err:1, '.');
		end; (* if *)
	end; (* if *)
	writeln('Done. Press command-Q to Quit.');
end. (* PExample *)